Bug 1013258 - Review Request: xombrero - Minimalist vi-like web browser with designed-in security features
Review Request: xombrero - Minimalist vi-like web browser with designed-in se...
Status: CLOSED DEFERRED
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Nobody's working on this, feel free to take it
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-09-28 16:48 EDT by Lokesh Mandvekar
Modified: 2014-07-01 18:59 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-02-09 19:51:42 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Lokesh Mandvekar 2013-09-28 16:48:13 EDT
Spec URL: http://lsm5.fedorapeople.org/rpmbuild/SPECS/xombrero.spec
SRPM URL: http://lsm5.fedorapeople.org/rpmbuild/SRPMS/xombrero-1.6.3-1.fc21.src.rpm

Description:
Xombrero is a minimalist web browser with sophisticated security features
designed-in, rather than through an add-on after-the-fact. In particular, it
provides both persistent and per-session controls for scripts and cookies,
making it easy to thwart tracking and scripting attacks. In addition to
providing a familiar mouse-based interface like other web browsers, it
offers a set of vi-like keyboard commands for users who prefer to keep their
hands on their keyboard.

Fedora Account System Username: lsm5

Koji: http://koji.fedoraproject.org/koji/taskinfo?taskID=5998886

$ rpmlint SPECS/xombrero.spec 
0 packages and 1 specfiles checked; 0 errors, 0 warnings.

$ rpmlint SRPMS/xombrero-1.6.3-1.fc21.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

$ rpmlint RPMS/x86_64/xombrero-1.6.3-1.fc21.x86_64.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
Comment 1 Christopher Meng 2013-09-28 19:03:53 EDT
CCing cuz I've packaged it. Thanks!
Comment 2 Lokesh Mandvekar 2013-09-28 19:07:16 EDT
(In reply to Christopher Meng from comment #1)
> CCing cuz I've packaged it. Thanks!

Have you packaged it for fedora already? I didn't find it in pkgs. Something I missed?
Comment 3 Christopher Meng 2013-09-28 19:15:44 EDT
No, I haven't submitted to the review because of no time. Please go ahead.
Comment 4 Lokesh Mandvekar 2013-09-28 19:50:40 EDT
(In reply to Christopher Meng from comment #3)
> No, I haven't submitted to the review because of no time. Please go ahead.

Alright, let me know in case you're interested in co-maintaining it (unless you're provenpackager already :) )
Comment 5 Antonio Trande 2013-09-29 11:20:55 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package installs a %{name}.desktop using desktop-file-install or desktop-
  file-validate if there is such a file.
  Please add a desktop-file-validate command
  http://fedoraproject.org/wiki/Packaging:Guidelines#desktop-file-install_usage

- update-desktop-database is invoked in %post and %postun if package contains
  desktop file(s) with a MimeType: entry.
  Note: desktop file(s) with MimeType entry in xombrero
  See: http://fedoraproject.org/wiki/Packaging:ScriptletSnippets#desktop-
  database

- Compilation uses also source file 'xombrero-1.6.3/js-merge-helper.pl' that is released
  with MIT license, like so License-JavaScript seems to me a MIT.
  Also, there is a "Combined Dual and Multiple Licensing Scenario" since License-tld-rules for 'tld-rules' file is licensed with a multiple license (MPLv1.1 or GPLv2+ or LGPLv2+). 
 http://fedoraproject.org/wiki/Packaging:LicensingGuidelines#Combined_Dual_and_Multiple_Licensing_Scenario
  'style.css' file is released with a CC-BY-SA license (see https://opensource.conformal.com/wiki/xombrero#style.css_license), 
  it's missing in the package.

  Please fix License tag that, in my opinion, is 
  
        ISC and MIT and CC-BY-SA and (MPLv1.1 or GPLv2+ or LGPLv2+)

- %defattr present but not needed. Please, remove its line.

- %{_datadir}/%{name} directory must be owned by the package

- Make file does not honor applicable compiler flags
  http://fedoraproject.org/wiki/Packaging:Guidelines#Compiler_flags and 
  http://fedoraproject.org/wiki/Packaging:RPMMacros#Build_flags_macros_and_variables
  
  Please, patch the Make file in order to use all flags correctly. 
   


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "ISC", "BSD (3 clause)", "MIT/X11 (BSD like)", "Unknown or generated",
     "BSD (2 clause)". 6 files have unknown license. Detailed output of
     licensecheck in /home/sagitter/1013258-xombrero/licensecheck.txt
[!]: Package requires other packages for directories it uses.
    Note: No known owner of /usr/share/xombrero
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/xombrero
[!]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[!]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed
[-]: Development files must be in a -devel package
[-]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 4 files.
[!]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: xombrero-1.6.3-1.fc21.i686.rpm
          xombrero-1.6.3-1.fc21.src.rpm
2 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint xombrero
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'



Requires
--------
xombrero (rpmlib, GLIBC filtered):
    config(xombrero)
    libX11.so.6
    libatk-1.0.so.0
    libbsd.so.0
    libbsd.so.0(LIBBSD_0.2)
    libc.so.6
    libcairo-gobject.so.2
    libcairo.so.2
    libdl.so.2
    libgdk-3.so.0
    libgdk_pixbuf-2.0.so.0
    libgio-2.0.so.0
    libglib-2.0.so.0
    libgnutls.so.28
    libgnutls.so.28(GNUTLS_1_4)
    libgobject-2.0.so.0
    libgtk-3.so.0
    libjavascriptcoregtk-3.0.so.0
    libpango-1.0.so.0
    libpangocairo-1.0.so.0
    libpthread.so.0
    libsoup-2.4.so.1
    libwebkitgtk-3.0.so.0
    rtld(GNU_HASH)



Provides
--------
xombrero:
    config(xombrero)
    mimehandler(application/vnd.mozilla.xul+xml)
    mimehandler(application/xhtml+xml)
    mimehandler(text/html)
    mimehandler(text/mml)
    mimehandler(text/xml)
    xombrero
    xombrero(x86-32)



Source checksums
----------------
https://opensource.conformal.com/snapshots/xombrero/xombrero-1.6.3.tgz :
  CHECKSUM(SHA256) this package     : 481011c136206f7aa3ab4cdf49ad77f81df4d5585f9e9a20c651bfaaaa537f79
  CHECKSUM(SHA256) upstream package : 481011c136206f7aa3ab4cdf49ad77f81df4d5585f9e9a20c651bfaaaa537f79


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -m fedora-rawhide-i386 -b 1013258
Buildroot used: fedora-rawhide-i386
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG
Comment 6 Lokesh Mandvekar 2013-09-29 18:51:43 EDT
* Sun Sep 29 2013 Lokesh Mandvekar <lsm5@fedoraproject.org> 1.6.3-2
- directories owned by package
- desktop file installed using desktop-file-install
- License tag updated and CC-BY-SA license added
- Makefile patched with appropriate compiler flags


SRPM URL: http://lsm5.fedorapeople.org/rpmbuild/SRPMS/xombrero-1.6.3-2.fc21.src.rpm

Check it out. Thanks!
Comment 7 Christopher Meng 2013-09-30 03:10:29 EDT
You can add me as maintainer. ;) But I won't do any updates unless you forget to update it in 3 weeks.

My review:

1. I hope you can add comments of these 4 license sources that indicates where do they come from.

2. 
%dir %attr(755,root,root) %{_datadir}/%{name}
%{_datadir}/%{name}/hsts-preload
%{_datadir}/%{name}/style.css
%{_datadir}/%{name}/tld-rules
%{_datadir}/%{name}/tordisabled.ico
%{_datadir}/%{name}/torenabled.ico
%{_datadir}/%{name}/%{name}.css
%{_datadir}/%{name}/%{name}icon128.png
%{_datadir}/%{name}/%{name}icon16.png
%{_datadir}/%{name}/%{name}icon32.png
%{_datadir}/%{name}/%{name}icon48.png
%{_datadir}/%{name}/%{name}icon64.png


Why not 

%{_datadir}/%{name}

?

3. Looking into source code again.

(i)
In makefile install section, no install -p option available, please notify upstream and include the patch in your patch0.

(ii)
In makefile:

-----------

all: javascript.h tooltip.h xombrero

javascript.h: ../js-merge-helper.pl ../hinting.js ../autoscroll.js
	perl ../js-merge-helper.pl ../hinting.js ../input-focus.js \
	../autoscroll.js > javascript.h

tooltip.h: ../ascii2txt.pl ../txt2tooltip.pl ../xombrero.1
	nroff -c -Tascii -mandoc ../xombrero.1 | \
	perl ../ascii2txt.pl | \
	perl ../txt2tooltip.pl > tooltip.h

-----------

[rpmaker@fab SPECS]$ rpm -qf /usr/bin/nroff
groff-base-1.22.2-7.fc20.i686

Missing BRs? Not sure becasue if I yum removed it will cause removing perl package itself.

(iii)
In makefile again and again ;)

-----------
LIBS= glib-2.0

> [omit]

LIBS+= libsoup-2.4 gnutls libbsd

-----------

Missing BR of libsoup-devel and gnutls-devel?(This is added in my spec, I just commented here)

4. Should we also build against webkitgtk2?
Comment 8 Antonio Trande 2013-09-30 10:41:06 EDT
(In reply to Christopher Meng from comment #7)
> You can add me as maintainer. ;) But I won't do any updates unless you
> forget to update it in 3 weeks.
> 
> My review:
>

Thanks for your cooperation, Christopher.


(In reply to  Lokesh Mandvekar from comment #6)

Please, post both SPEC link and SRPM link as soon as your changes have been performed also according to Christopher points.
Comment 9 Antonio Trande 2013-10-19 05:57:58 EDT
Any news ?
Comment 10 Lokesh Mandvekar 2013-10-19 17:15:21 EDT
(In reply to Antonio Trande from comment #9)
> Any news ?

Sorry I've been occupied with golang deps which were kinda urgent, I'll get to this soon :)
Comment 11 Christopher Meng 2014-01-09 04:19:25 EST
(In reply to Lokesh Mandvekar from comment #10)
> (In reply to Antonio Trande from comment #9)
> > Any news ?
> 
> Sorry I've been occupied with golang deps which were kinda urgent, I'll get
> to this soon :)

docker? Nice, I like it, hope to hear good news of this one from you soon.
Comment 12 Lokesh Mandvekar 2014-01-09 13:23:22 EST
(In reply to Christopher Meng from comment #11)
> (In reply to Lokesh Mandvekar from comment #10)
> > (In reply to Antonio Trande from comment #9)
> > > Any news ?
> > 
> > Sorry I've been occupied with golang deps which were kinda urgent, I'll get
> > to this soon :)
> 
> docker? Nice, I like it, hope to hear good news of this one from you soon.

Yup. Sure thing. Apologies this has been delayed a lot. But if anyone would like to take ownership of this, I can transfer it.

Note You need to log in before you can comment on or make changes to this bug.